//+------------------------------------------------------------------+
//|                                           Henderson's filter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int Price      = PRICE_CLOSE;
extern int FilterSize = 13;

//
//
//
//
//

double buffer1[];
double weights[];
int half;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
      FilterSize = MathMax(FilterSize,3);
         if (MathMod(FilterSize,2)==0) FilterSize++; ArrayResize(weights,FilterSize);
          

   //
   //
   //
   //
   //
            
   double m = MathFloor(FilterSize/2.0); half = m;
   double divisor = 8.0*(m+2.0)*((m+2.0)*(m+2.0)-1.0)*(4.0*(m+2.0)*(m+2)-1.0)*(4.0*(m+2.0)*(m+2.0)-9.0)*(4.0*(m+2.0)*(m+2.0)-25.0);  
   for (int j=-half; j<=half; j++)
      weights[j+half] = 315.0*((m+1.0)*(m+1.0)-(j*j))*((m+2.0)*(m+2.0)-(j*j))*((m+3.0)*(m+3.0)-(j*j))*(3.0*(m+2.0)*(m+2.0)-11.0*(j*j)-16.0)/divisor;

      //
      //
      //
      //
      //
      
   SetIndexDrawBegin(0,half);
   return(0);
}
int deinit() { return(0); }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();
   int size = ArraySize(weights);

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,half),Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double mod = 1.0;
      if (i<half)
      {
         double weightTotal = 0; for (int k=half-i; k<size; k++) weightTotal += weights[k]; mod = 1.0/weightTotal;               
      }
         
      //
      //
      //
      //
      //
               
      double sum = mod*weights[half]*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      for(int j=1; j<=half; j++)
      {
         if (j<=i) sum += mod*weights[half+j]*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
                   sum += mod*weights[half-j]*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
      }
      buffer1[i] = sum;
   }            
   return(0);
}